Program Culmi;

Const MAX = 10000;

Type Dim = 1..MAX;
     Vector = Array[Dim] Of Word;

Var X, S: Vector; {X - vectorul initial; S[i] - ultimul element din subsirul i}
    Fin, Fout: Text;
    N, NrS: Dim;  {NrS - numar subsiruri}

Procedure Init;
Var i: Dim;
Begin
  Assign(Fin, 'culmi.in'); Reset(Fin);
  Assign(Fout, 'culmi.out'); ReWrite(Fout);
  FillChar(S, SizeOf(S), 0);
End;

Procedure Gata;
Begin
  Close(Fin);
  Close(Fout)
End;

Procedure Citire;
Var i: Dim;
Begin
  ReadLn(Fin, N);
  For i := 1 To N Do ReadLn(Fin, X[i])
End;

Procedure Subsiruri;
Var i, j: Dim;
Begin
  S[1] := X[1];        {primul element va fi in subsirul 1}
  NrS := 1;            {am un subsir}
  For i := 2 To N Do   {iau pe rand elementele din vectorul X}
    Begin              {si caut primul subsir care are ultimul element }
      j := 1;          {strict mai mic ca acesta}
      While (j<=NrS) And (X[i]<=S[j]) Do Inc(j);
      If j>NrS Then NrS := j;  {daca nu am gasit am un nou subsir}
      S[j] := X[i]     {pun elementul ca ultim element in subsir}
    End;
  WriteLn(Fout, NrS)
End;

Begin
  Init;
  Citire;
  Subsiruri;
  Gata
End.