#include <stdlib.h>
#include <stdio.h>

#define MAX      10000

int X[MAX+1], S[MAX+1]; //X - vectorul initial; S[i] - ultimul element din subsirul i
int N, NrS;             //NrS - numar subsiruri

FILE *Fin, *Fout;

void Init(void)
{
  int i;
  Fin = fopen("culmi.in", "r");
  Fout = fopen("culmi.out", "w");
  for(i=1; i<=MAX; i++) S[i]=0;
}

void Citire(void)
{
  int i;
  fscanf(Fin, "%d", &N);
  for(i=1; i<=N; i++) fscanf(Fin, "%d", &X[i]); 
}

void Subsiruri(void)
{
  int i, j;
  S[1]=X[1];          //primul element va fi in subsirul 1
  NrS=1;              //am un subsir
  for(i=2; i<=N; i++) //iau pe rand elementele din vectorul X
    {                 //si caut primul subsir care are ultimul element
      j=1;            //strict mai mic ca acesta
      while((j<=NrS) && (X[i]<=S[j])) j++;
      if (j>NrS) NrS=j;//daca nu am gasit am un nou subsir
      S[j]=X[i];      //pun elementul ca ultim element in subsir
    }
  fprintf(Fout, "%d\n", NrS);
}

int main(void)
{
  Init();
  Citire();
  Subsiruri();
  fclose(Fin);
  fclose(Fout);
  return(0);
}
