Program Numere_Mari;

Type Huge = Array[0..1000] Of Byte;

Var NRHuge, A: Huge;
    n, i, d, nr, dmax: LongInt;
    p: Array[2..50000] Of Byte;
    Fin, Fout: Text;

Procedure AtribHuge(Var X: Huge; A: LongInt);
Var i: Integer;
Begin
  X[0] := 0;
  Repeat
    Inc(X[0]);
    X[X[0]] := A MOD 10;
    A := A DIV 10
  Until A=0;
End;

Procedure MultHuge(X, Y: Huge; Var Z: Huge);
Var i, j, T: Integer;
    AUX: Huge;
Begin                      {  Z = X * Y  }
  T := 0;
  AUX[0] := X[0]+Y[0]-1;
  For i := 1 To AUX[0] Do AUX[i] := 0;
  For i := 1 To X[0] Do
    For j := 1 To Y[0] Do
      AUX[i+j-1] := AUX[i+j-1] + X[i]*Y[j];
  For i := 1 To AUX[0] Do
    Begin
      AUX[i] := AUX[i] + T;
      T := AUX[i] DIV 10;
      AUX[i] := AUX[i] MOD 10
    End;
  If T>0 Then
    Begin
      Inc(AUX[0]);
      AUX[AUX[0]] := T
    End;
  For i := 0 To AUX[0] Do Z[i] := AUX[i];
End;

Procedure AddHuge(X, Y: Huge; Var Z: Huge);
Var i, j, T: Integer;
    AUX: Huge;
Begin                      {  Z = X + Y  }
  T := 0;
  If X[0]>Y[0] Then
    Begin
     AUX[0] := X[0];
     For i := Y[0]+1 To X[0] Do Y[i] := 0
    End
  Else
    Begin
     AUX[0] := Y[0];
     For i := X[0]+1 To Y[0] Do X[i] := 0
    End;
  For i := 1 To X[0] Do
    Begin
      AUX[i] := X[i] + Y[j] + T;
      T := AUX[i] DIV 10;
      AUX[i] := AUX[i] MOD 10
    End;
  If T>0 Then
    Begin
      Inc(AUX[0]);
      AUX[AUX[0]] := T
    End;
  For i := 0 To AUX[0] Do Z[i] := AUX[i];
End;

Procedure WriteHuge(X: Huge);
Var i: Integer;
Begin
  For i := X[0] DownTo 1 Do Write(Fout, X[i]);
  WriteLn(Fout)
End;

Begin
  Assign(Fin, 'sqr.in'); Reset(Fin);
  ReadLn(Fin, n);
  For i := 1 To n Do
    Begin
      ReadLn(Fin, nr);
      d := 2;
      While nr>1 Do
        Begin
          While nr MOD d=0 Do
            Begin
              Inc(p[d]);
              nr := nr DIV d
            End;
          d := d+1
        End;
      If d>dmax Then dmax := d
    End;

  AtribHuge(NRHuge, 1);
  For i := 2 To dmax Do
    If (p[i]>0) AND (p[i] MOD 2=1) Then
      Begin
        AtribHuge(A, i);
        MultHuge(NRHuge, A, NRHuge)
      End;

  Assign(Fout, 'sqr.out'); ReWrite(Fout);
  WriteHuge(NRHuge);
  Close(Fin); Close(Fout);
End.